<template>
  <div>
  <!-- Start Content-->
  <div class="container-fluid">

    <!-- start page title -->
    <div class="row">
      <div class="col-12">
        <div class="page-title-box">
          <h4 class="page-title">Заказы</h4>
        </div>
      </div>
    </div>
    <!-- end page title -->

    <div class="row">
      <div class="col-12">
        <div class="card">
          <div class="card-body">
            <div class="row mb-2" v-if="false">
              <div class="col-lg-8">
                <form class="form-inline">
                  <div class="form-group mb-2">
                    <label for="inputPassword2" class="sr-only">Search</label>
                    <input type="search" class="form-control" id="inputPassword2" placeholder="Search...">
                  </div>
                  <div class="form-group mx-sm-3 mb-2">
                    <label for="status-select" class="mr-2">Status</label>
                    <select class="custom-select" id="status-select">
                      <option selected>Choose...</option>
                      <option value="1">Paid</option>
                      <option value="2">Awaiting Authorization</option>
                      <option value="3">Payment failed</option>
                      <option value="4">Cash On Delivery</option>
                      <option value="5">Fulfilled</option>
                      <option value="6">Unfulfilled</option>
                    </select>
                  </div>
                </form>
              </div>
              <div class="col-lg-4">
                <div class="text-lg-right">
                  <button type="button" class="btn btn-danger waves-effect waves-light mb-2 mr-2"><i class="mdi mdi-basket mr-1"></i> Add New Order</button>
                  <button type="button" class="btn btn-light waves-effect mb-2">Export</button>
                </div>
              </div><!-- end col-->
            </div>

            <div class="table-responsive">
              <table class="table table-centered table-nowrap mb-0">
                <thead class="thead-light">
                <tr>
                  <th style="width: 20px;"  v-if="false">
                    <div class="custom-control custom-checkbox">
                      <input type="checkbox" class="custom-control-input" id="customCheck1">
                      <label class="custom-control-label" for="customCheck1">&nbsp;</label>
                    </div>
                  </th>
                  <th>ID Заказа</th>
                  <th v-if="company_type == 'manufacturer'">Покупатель</th>
                  <th v-else>Продавец</th>
                  <th>Дата заказа</th>
                  <th>Статус заказа</th>
                  <th style="width: 125px;">Действия</th>
                </tr>
                </thead>
                <tbody>
                <template v-if="orders.length > 0">
                  <tr v-for="order in orders">
                    <td v-if="false">
                      <div class="custom-control custom-checkbox">
                        <input type="checkbox" class="custom-control-input" id="customCheck2">
                        <label class="custom-control-label" for="customCheck2">&nbsp;</label>
                      </div>
                    </td>
                    <td><NuxtLink :to="'/orders/'+ order.order_number" class="text-body font-weight-bold">{{order.order_number}}</NuxtLink> </td>
                    <td>
                      {{order.company_name}}
                    </td>
                    <td>
                      {{order.date}}
                    </td>
                    <td>
                      <h5>
                        <span class="badge badge-info" v-if="order.status == 'pending'">В ожидании</span>
                        <span class="badge badge-success" v-else-if="order.status == 'success'">Подтвержден</span>
                        <span class="badge badge-warning" v-else-if="order.status == 'rejected'">Отменен</span>
                      </h5>
                    </td>
                    <td>
                      <NuxtLink :to="'/orders/'+ order.order_number" class="action-icon"><i class="mdi mdi-eye"></i></NuxtLink>
                      <a href="javascript:void(0);" class="action-icon" data-toggle="modal" data-target="#full-width-modal" @click="getOrder(order.order_number)" v-if="company_type == 'manufacturer' && order.status == 'pending'"> <i class="mdi mdi-square-edit-outline"></i></a>
                      <a href="javascript:void(0);" class="action-icon" v-if="false"> <i class="mdi mdi-delete"></i></a>
                    </td>
                  </tr>
                </template>
                <template v-else>
                  <tr><td colspan="8" style="text-align: center">Нет данных для отображения</td></tr>
                </template>

                </tbody>
              </table>
            </div>

            <Pagination v-model="page" :pageCount="pageCount" :route="this.$route" v-if="pageCount > 1"></Pagination>
          </div> <!-- end card-body-->
        </div> <!-- end card-->
      </div> <!-- end col -->
    </div>
    <!-- end row -->

  </div> <!-- container -->

    <!-- Full width modal content -->
    <div id="full-width-modal" class="modal fade" tabindex="-1" role="dialog" aria-labelledby="fullWidthModalLabel" aria-hidden="true">
      <div class="modal-dialog modal-full-width">
        <div class="modal-content">
          <div class="modal-header">
            <h4 class="modal-title" id="fullWidthModalLabel">Редактирование заказа #{{order_number}}</h4>
            <button type="button" class="close" data-dismiss="modal" aria-hidden="true">×</button>
          </div>
          <div class="modal-body">
            <div class="table-responsive">
              <table class="table table-bordered table-centered mb-0">
                <thead class="thead-light">
                <tr>
                  <th>Наименование товара</th>
                  <th>Товар</th>
                  <th>Размеры</th>
                  <th>Количество</th>
                  <th>Цена</th>
                  <th>Стоимость</th>
                  <th>Скидка</th>
                  <th>Всего</th>
                </tr>
                </thead>
                <tbody>
                <template v-for="product in products">
                  <tr v-show="company_type == 'customer'"><td colspan="6">Компания {{product.company_name}} (Тел.: {{product.company_mobilephone}}, E-mail: {{product.company_email}})</td></tr>
                  <template v-for="product_data in product.product_data">
                    <tr v-for="(size, index) in product_data.product_sizes">
                      <th scope="row" :rowspan="countSizes(product_data.properties.size)" v-if="index == 0">{{ product_data.product_name }}</th>
                      <td :rowspan="countSizes(product_data.properties.size)" v-if="index == 0"><img :src="product_data.product_images[0]" alt="product-img" height="150"></td>
                      <td>
                        <table border="0">
                          <tr>
                            <td>{{ size.title }}</td>
                            <td><input type="number" min="0" :name="'size['+product_data.product_id+']['+size.value+']'" :value="product_data.ordered_sizes[index].stock" class="form-control" :ref="size.value" placeholder="0" @change="currentSizes($event, product_data.product_id, index, size.value, size.stock, product_data.manufacturer_id)"></td>
                            <td>шт.</td>
                          </tr>
                        </table>
                      <td :rowspan="countSizes(product_data.properties.size)" v-if="index == 0">{{ product_data.quantity }} шт.</td>
                      <td :rowspan="countSizes(product_data.properties.size)" v-if="index == 0">{{ product_data.price }} р.</td>
                      <td :rowspan="countSizes(product_data.properties.size)" v-if="index == 0">{{ product_data.price * product_data.quantity }} р.</td>
                      <td :rowspan="countSizes(product_data.properties.size)" v-if="index == 0">{{ product_data.product_discount }} р.</td>
                      <td :rowspan="countSizes(product_data.properties.size)" v-if="index == 0">{{ product_data.product_total }} р.</td>
                    </tr>
                  </template>
                </template>
                <tr>
                  <td>Статус:
                    <multiselect
                      v-model="status"
                      :options="statuses"
                      :multiple="false"
                      :close-on-select="true"
                      :clear-on-select="false"
                      :preserve-search="true"
                      select-label="Нажмите для выбора"
                      selected-label="Выбрано"
                      deselect-label="Нажмите для удаления"
                      placeholder="Выберите статус заказа"
                      label="title"
                      track-by="value"
                      :preselect-first="true"
                    /></td>
                  <th scope="row" colspan="2" class="text-right">Итого :</th>
                  <td><div class="font-weight-bold">{{quantity}} шт.</div></td>
                  <td><div class="font-weight-bold">{{price}} р.</div></td>
                  <td><div class="font-weight-bold">{{price * quantity}} р.</div></td>
                  <td><div class="font-weight-bold">{{discount}} р.</div></td>
                  <td><div class="font-weight-bold">{{price_total}} р.</div></td>
                </tr>
                </tbody>
              </table>
            </div>
          </div>
          <div class="modal-footer">
            <button type="button" class="btn btn-light" data-dismiss="modal">Закрыть</button>
            <button type="button" class="btn btn-primary" @click.prevent="saveOrder">Сохранить</button>
          </div>
        </div><!-- /.modal-content -->
      </div><!-- /.modal-dialog -->
    </div><!-- /.modal -->
  </div>
</template>

<script>
export default {
  name: "index",
  data(){
    return {
      order_id: 0,
      product_name: '',
      company_name: '',
      company_email: '',
      company_mobilephone: '',
      sizes: {},
      quantity: 0,
      price: 0,
      total: 0,
      price_total: 0,
      discount: 0,
      summ: 0,
      products: {},
      orders: {},
      order_number: '',
      company_type: '',
      currentSelectedSizes: {},
      page: '',
      pageCount: 1,
      isLoading: true,
      status: '',
      statuses: [
        { value: 'success', title: 'Принят' },
        { value: 'rejected', title: 'Отменен' },
      ],
    }
  },
  beforeCreate () {
    this.$axios.get('/orders')
      .then(resp => {
        this.orders = resp.data.orders;
        this.company_type = resp.data.company_type;
        this.pageCount = resp.data.last_page;
        this.isLoading = false;
        //this.getOrders(resp.data);
      }).catch(function(){
      console.log('Error 123');
    });
  },
  methods:{
    getOrders(orders){
      let i = 0;
      for(let order in orders){
        for(let orderData in orders[order]){
          this.orders[i] = orders[order][orderData];
          i++;
        }
      }
    },
    getOrder(order_number){
      this.$axios.get('/orders/show',{
        params: {
          number: order_number
        }
      })
        .then(resp => {
          this.company_type = resp.data.company_type;
          this.products = resp.data.products;
          this.order_number = order_number;
          this.quantity = resp.data.total_quantity;
          this.order_id = resp.data.order_id;
          this.price = resp.data.total_price;
          this.price_total = resp.data.total_summ;
          this.discount = resp.data.total_discount;
          this.company_name = resp.data.company_name;
          this.company_email = resp.data.company_email;
          this.company_mobilephone = resp.data.company_mobilephone;
          this.getSizes();
        }).catch(function(){
        console.log('Error 123');
      });
    },
    countSizes(sizes){
      return sizes.length;
    },
    saveOrder(){
      this.$axios.post('/orders/update',{
          order_id: this.order_id,
          products: this.products,
          status: this.status,
      })
        .then(resp => {

        }).catch(function(){
        console.log('Error 123');
      });
    },
    currentSizes(el, product_id, index, size_value, stock, manufacturer_id)
    {

      console.log(stock);

      // Проверить логику увеличения количества, учитывая уже заказанное количество и доступный ассортимено. Должна быть уже имеющееся количество + остаток в товаре
      if(stock > 0) {
        if (el.target.value > stock) {
          el.target.value = stock;
        } else if (el.target.value < 0 || el.target.value == '') {
          el.target.value = 0;
        }
      }else{
        if (el.target.value > this.sizes[product_id][size_value]) {
          el.target.value = this.sizes[product_id][size_value];
        } else if (el.target.value < 0 || el.target.value == '') {
          el.target.value = 0;
        }
      }

      //this.products[manufacturer_id].product_data[product_id].sizes[index].stock = el.target.value;
      this.products[manufacturer_id].product_data[product_id].ordered_sizes[index] = {'stock':el.target.value};

      this.products[manufacturer_id].product_data[product_id].total = 0;
      let product_total = 0;
      let product_discount = 0;
      let quantity = 0;

      for(let size in this.products[manufacturer_id].product_data[product_id].ordered_sizes){

        quantity += +this.products[manufacturer_id].product_data[product_id].ordered_sizes[size].stock;

        if(this.products[manufacturer_id].product_data[product_id].is_percent){
          product_discount = product_discount + (this.products[manufacturer_id].product_data[product_id].ordered_sizes[size].stock * this.products[manufacturer_id].product_data[product_id].price * this.products[manufacturer_id].product_data[product_id].discount);
        }else{
          product_discount = product_discount + (this.products[manufacturer_id].product_data[product_id].ordered_sizes[size].stock * this.products[manufacturer_id].product_data[product_id].discount);
        }
      }

      product_total = this.products[manufacturer_id].product_data[product_id].price * quantity - product_discount;

      this.products[manufacturer_id].product_data[product_id].quantity = quantity;
      this.products[manufacturer_id].product_data[product_id].product_discount = product_discount;
      this.products[manufacturer_id].product_data[product_id].product_total = product_total;

      this.price_total = 0;
      this.discount = 0;
      this.quantity = 0;
      this.summ = 0;

      for(let product in this.products){
        for(let productData in this.products[product].product_data){
          this.quantity += this.products[product].product_data[productData].quantity;
          this.price_total += this.products[product].product_data[productData].product_total;
          this.discount += this.products[product].product_data[productData].product_discount;
        }
      }


      this.summ = this.price_total;

      if(product_id in this.currentSelectedSizes == false){
        this.currentSelectedSizes[product_id] = {};
      }
      if(el.target.value > 0){
        this.currentSelectedSizes[product_id][size_value] = {'value':el.target.value};
      }else if(this.currentSelectedSizes[product_id][size_value] && el.target.value == 0){
        delete this.currentSelectedSizes[product_id][size_value];
      }
    },
    getSizes(){
      for(let product in this.products){
        for(let productDataId in this.products[product].product_data){
          this.sizes[productDataId] = {};
          for(let size in this.products[product].product_data[productDataId].ordered_sizes){
            this.sizes[productDataId][size] = this.products[product].product_data[productDataId].ordered_sizes[size];
          }
        }
      }
    },
  },
}
</script>

<style scoped>

</style>
